#include <array>
#include <cstdint>
#include <iostream>
#include <random>
#include <stdexcept>
#include <string>
#include <type_traits>
#include <utility>
#include <variant>

using namespace std;
using ll = int64_t;

template<class T,class P>
ostream&operator<<(ostream&os,pair<T,P>const&p){
    os<<"( "<<p.first<<", "<<p.second<<" )";
    return os;
}

variant<ll,string> test(){
    random_device v;
    mt19937 mt(v());
    uniform_int_distribution<short> un(0,50);
    ll number{un(mt)};
    if(!number){
        return "Zengtudor";
    }
    return number;
}

template<class... Ts> struct overloaded : Ts... { using Ts::operator()...; };
template<class... Ts> overloaded(Ts...) -> overloaded<Ts...>;

template<class T,class ...Args>
struct Array{
    static constexpr ll size(){return sizeof...(Args)+1;}
    decay_t<T> arr[size()];
    Array(T const&t, Args const&...args){
        arr[0]=t;
        ll idx{1};
        ((arr[idx++]=args),...);
    }
    friend ostream&operator<<(ostream&os,Array const&arr){
        os<<"[ ";
        for(ll i{0};i<size();i++){
            os<<arr.arr[i]<<" ,";
        }
        cout<<" ]";
        return os;
    }
};

// template<class T,class ...Args>
// Array(T,Args...)->Array<T,Args...>;

int main(){
    array<int,2> a{};
    for(auto const& i:a)cout<<i<<" ";
    cout<<'\n';
    Array arr {1,2,3};
    cout<<arr<<'\n';
    // cout<<sizeof(test())<<'\n';
    // ll n{100};
    // // cin>>n;
    // while(n--){
    //     cout<<visit(overloaded{
    //         [](string const&str){cout<<"is str\n";throw runtime_error("throwing error");return 1;},
    //         [](ll const& n){cout<<"is number\n";return 2;}
    //     },test())<<"\n";
    // }
}